
module FFJ.Syntax where {

	type Identifier = String;
	type Type = Identifier;
	type Variable = Identifier;
	type Class = (Bool, Identifier, Type, [Field], [Method]);
	type Field = (Type, Identifier);
	type Method = (Bool, Type, Identifier, [Param], Term);
	type Param = (Type, Variable);
	type MethodBody = ([Variable], Term);
	type Signature = ([Type], Type);

	data Term = Var Variable | Proj Term Identifier | Inv Term Identifier [Term] | Inst Type [Term] | Cast Type Term deriving Show;
	
}
