module FFJPL.Subtype where {
	import FFJ.Syntax;
	import FFJPL.Definitions;
	import FFJPL.Functions;
	import FFJPL.Predicates;
	import FFJPL.FeatureModel;
 
	isSubType :: FeatureModel -> CT -> Type -> Type -> [Feature] -> Bool; -- subtype relation
	isSubType fm ct c e omegas
		| (c == e) = True
		| otherwise = (validRef fm ct omegas c) && 
		              (and (map (\x -> if (sometimes fm omegas x) 
		                          then ((validRef fm ct (x:omegas) (getSuperClass ct (c,x))) && (isSubType fm ct ((getSuperClass ct (c,x))) e (x:omegas))) 
		                          else True) 
		                          (getIntroductions fm ct c)
		               ));

	subTypesAllVariants :: FeatureModel -> CT -> [[Type]] -> [[Type]] -> [Feature] -> Bool;
	subTypesAllVariants fm ct css (ds:dss) omegas = (and (map (\x -> subTypes fm ct x ds omegas) (getArgTypes css))) && (subTypesAllVariants fm ct css dss omegas);
	subTypesAllVariants fm ct css [] omegas = True;

	getArgTypes :: [[Type]] -> [[Type]];
	getArgTypes [] = [[]];
	getArgTypes ([]:xs) = [];
	getArgTypes ((y:ys):xs) = [ y:l | l <- getArgTypes xs ] ++ getArgTypes (ys:xs);

	subTypes :: FeatureModel -> CT -> [Type] -> [Type] -> [Feature] -> Bool;
	subTypes fm ct (c:cs) (d:ds) omegas = if (length cs == length ds) then  (isSubType fm ct c d omegas) && (subTypes fm ct cs ds omegas) else False;
	subTypes fm ct [] [] omegas = True;
	subTypes fm ct cs [] omegas = False;
	subTypes fm ct [] ds omegas = False;

}