
module FJ.Test where {
	import FJ.Syntax;
	import FJ.Program;
	import FJ.AuxFunc;
	import FJ.Semantics;
	import FJ.Typing;
	import FJ.Print;
	import FJ.Parser;
	import FJ.Adapter;
	import Maybe;
	import System.IO;

	parse :: String -> [PStat];
	parse = parser . lexer;
	
	main = do {
		x <- readFile "FJ/test/Pair.java";
		let {y = parse x;};
		putStr "Class Table:\n\n";
		let {(ct,pt) = getprog (initct,initpt) y;};
		printct ct;
		putStr ("\n\n" ++ "Source Programs:\n\n");
		printpt pt;
		putStr ("\n\n" ++ "Source Programs (variables substituted):\n\n");
		let {pts = (substpt pt);};
		printpt pts;
		if (allOK ct pts) == False then error "Class table or programs are not well-formed!" else putStr "";
		let { ept = evalpt ct pts; };
		putStr ("\n\n" ++ "Evaluated Programs:\n\n");
		printpt ept;
	};
	

}
